
import 'package:marianum_mobile/api/marianumcloud/webdav/queries/listFiles/cacheableFile.dart';
import 'package:marianum_mobile/api/marianumcloud/webdav/queries/listFiles/listFilesParams.dart';
import 'package:marianum_mobile/api/marianumcloud/webdav/queries/listFiles/listFilesResponse.dart';
import 'package:marianum_mobile/api/marianumcloud/webdav/webdavApi.dart';
import 'package:nextcloud/nextcloud.dart';

class ListFiles extends WebdavApi<ListFilesParams> {
  ListFilesParams params;

  ListFiles(this.params) : super(params);

  @override
  Future<ListFilesResponse> run() async {
    List<WebDavFile> davFiles = (await (await WebdavApi.webdav).ls(params.path)).toWebDavFiles((await WebdavApi.webdav));
    davFiles.removeWhere((element) => element.path == "/${params.path}/" || element.path == "/"); // somehow the current working folder is also listed, it is filtered here.
    Set<CacheableFile> files = davFiles.map((e) => CacheableFile.fromDavFile(e)).toSet();

    return ListFilesResponse(files);
  }
}