import 'dart:convert';

import 'package:marianum_mobile/api/mhsl/message/getMessages/getMessagesResponse.dart';
import 'package:marianum_mobile/api/requestCache.dart';

import 'getMessages.dart';

class GetMessagesCache extends RequestCache<GetMessagesResponse> {
  GetMessagesCache({onUpdate, renew}) : super(RequestCache.cacheMinute, onUpdate, renew: renew) {
    start("MarianumMobile", "message");
  }

  @override
  GetMessagesResponse onLocalData(String json) {
    return GetMessagesResponse.fromJson(jsonDecode(json));
  }

  @override
  Future<GetMessagesResponse> onLoad() {
    return GetMessages().run();
  }
}